/*********************************************************************/
/*								     */
/*      makeBfnd()...     1995.11.16.  Lxy.                          */
/*								     */
/*********************************************************************/
#ifndef __TYPEDEF__
#   include "typedef.h"
#endif

#ifndef __BIF_DEF__
#   include "bif.h"
#endif

#ifndef __LL_DEF__
#   include "ll.h"
#endif

#ifndef __SYMB_DEF__
#   include "symb.h"
#endif

#include "makenodes.h"

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

char *
chkalloc(n)
int n;
{
        char *p;

        if (p = (char *) calloc(1, (unsigned) n))
                return (p);
        return NULL;
}
PTR_BFND
alloc_bfnd (fi)
        PTR_FILE fi;
{
        register PTR_BFND new;

        new = (struct bfnd *) chkalloc(sizeof(struct bfnd));
        new->id = ++(fi->num_bfnds);
        new->thread = BFNULL;
        if (fi->num_bfnds == 1)
                fi->head_bfnd = new;
        else
                fi->cur_bfnd->thread = new;
        fi->cur_bfnd = new;
        return (new);
}

PTR_BFND
makeBfnd(fi,node_type)
PTR_FILE fi;
int      node_type;
{
      PTR_BFND new_bfnd;

      new_bfnd = alloc_bfnd (fi);     /* should set up id field */
      new_bfnd->variant = node_type;
      new_bfnd->g_line = lineNum_g;      /*  yylineno , l_line  */
      new_bfnd->l_line = lineNum_l;
      new_bfnd->checked = HARD;
      new_bfnd->filename = cur_thread_file; 
      new_bfnd->entry.Template.ll_ptr1 = LLNULL;
      new_bfnd->entry.Template.ll_ptr2 = LLNULL;
      new_bfnd->entry.Template.ll_ptr3 = LLNULL;
      new_bfnd->entry.Template.symbol = SMNULL;
      new_bfnd->entry.Template.bl_ptr1 = BLNULL;
      new_bfnd->entry.Template.bl_ptr2 = BLNULL;
      new_bfnd->entry.Template.lbl_ptr=LBNULL;
      new_bfnd->entry.Template.cmnt_ptr=CMNULL;
      new_bfnd->entry.Template.bf_ptr1=BFNULL;

      new_bfnd->entry.Template.dep_ptr1=NULL;
      new_bfnd->entry.Template.dep_ptr2=NULL;
      new_bfnd->entry.Template.sets=NULL;
 
      last_bfnd=new_bfnd;
      return (new_bfnd);
}
